(function () {
	const 
		{Cc:$$Cc,Ci:$$Ci,Cu:$$Cu,Cr:$$Cr,Cm:$$Cm,CC:$$CC,ChromeWorker:$$ChromeWorker,components:$$components} = require('chrome')
		, $$buttons = require('sdk/ui/button/action')
		, $$data = require('sdk/self').data
		, $$winUtils = require('sdk/window/utils')
		, $$windowWatcher = $$Cc['@mozilla.org/embedcomp/window-watcher;1'].getService($$Ci.nsIWindowWatcher)
		, $$pageMod = require('sdk/page-mod')
		, $$tabs = require('sdk/tabs')
		, $$worker = require('sdk/content/worker')
		, $$ver = require('sdk/self').version
	;

	var _pri = {};

	var _init = function () {

		var button = $$buttons.ActionButton({
			id: 'alibaba_CTC_PTS_record_tool_btn',
			label: 'alibaba CTC PTS record tool',
			icon: {
				'16': './logo16.png',
				'32': './logo32.png',
				'64': './logo64.png'
			},
			onClick: function (evt) {

				_pri.startUpWindow();

			}
		});

		$$tabs.on('ready', function logURL(tab) {
			var worker = tab.attach({
				contentScriptFile: [
					$$data.url('win/lib/var_dump.js')
					, $$data.url('amd.js')
					, $$data.url('win/common/adapter.js')
					, $$data.url('content_script.js')
				],
				contentScript: [
					'requirejs([\'content_script\'], function($$p){',
						'$$p();',
					'});'

				].join('')
			});

			worker.port.on('ctPostToBg', function (oData) {
				//console.log(Object.keys(_pri.scriptCache));
				if(oData.cmd === 'ctsGetScriptDataFromBgsCache') {
					oData = oData.data;
					var oScriptData = _pri.scriptCache[oData.scriptCacheId];
					if(oData.scriptCacheId === 'i3bgzm5g-v527-1d99-wnpp-r6auahkdn5qu') {
						oScriptData = {
							script : 'script Test!',
							data : {}
						}
					}
					worker.port.emit('bgPostToCt', {
						cmd : 'bgsPostScriptDataToCts',
						data : oScriptData
					});
					delete _pri.scriptCache[oData.scriptCacheId];
				}else if(oData.cmd === 'startWin') {console.log('========     startWin     ===========');
					_pri.startUpWindow();
				}
			});
			//worker.port.on('postWinData', function (oData) {
				//_pri["toPageId"] = oData.pageId;
				//_pri["toScriptId"] = oData.scriptId;
				//_pri.postDataToWin('postWinData', oData);
			//});
		});

 
		

	};

	_pri["startUpWindow"] = function (oSpec) {
		oSpec = oSpec || {};
		if(!_pri.startServer.ok) {
			_pri.startServer();
		}
		_pri.win = $$windowWatcher.getWindowByName('alibaba_CTC_PTS_record_tool_win', this);
		if(!_pri.win) {
			_pri["win"] = _pri.createWin();
		}
		_pri.win.focus();

	};

	_pri["postHttpToWin"] = function (sType, oData) {
		//console.log('===================');
		//var oItem = Object.create(oData);
		//oItem.requestHeader = oItem.requestHeader.map(function (a) {
			//return a.join(' : ');
		//});
		//if(oItem.responseHeader) {
			//oItem.responseHeader = oItem.responseHeader.map(function (a) {
				//return a.join(' : ');
			//});
		//}
		//console.log(JSON.stringify(oItem, 0, 4));
		//console.log('------------------------------');
		_pri.postDataToWin('postHttp', {
			msg : sType,
			data : oData
		});
	};

	_pri["hasWin"] = function () {
		return Object.prototype.toString.call(_pri.win) !== '[object DeadObject]';
	};

	_pri["postDataToWin"] = function (sMsg, oData) {
		if(_pri.hasWin()) {
			_pri.win.postMessage({
				data : {
					msg : sMsg,
					data : oData
				},
				sign : _pri.postSign
			}, '*');
		}
	};

	_pri["postSign"] = 'bgPostToWin';

	_pri["bindWinDoc"] = (function () {
		var _fun = function (_spec) {
			if(_pri.win && !_pri.win.hasAddListen) {
				if(1||_fun.beLoaded()) {
					_fun.addListen();
					_pri.win.hasAddListen = true;
				}
			}
		};

		_fun['beLoaded'] = function () {
			if(_pri.win.document.body.childNodes.length) {
				return true;
			}else{
				return false;
			}
		};

		_fun['addListen'] = function () {
			_pri.win.addEventListener('message', function (evt) {
				var oData = evt.data;
				//console.log('====addEventListener=message====',evt.data.msg);
				if(oData.sign === 'winPostToBg') {
					delete oData.sign;
					_fun.costToBg(oData.data);
				}
			});
			//_pri.win.port.on('fromToolUi', function () {
				//console.log('== worker.port.on - fromToolUi ==');
			//});
			//console.log('##### addListen #####');
			//var sPostCache = _pri.win.document.body.getAttribute('postWinData');
			//if(sPostCache) {
				//JSON.parse(sPostCache).forEach(function (oMsg) {
					//_fun.costToBg(oMsg);
				//});
			//}
			//_pri.win.document.body.setAttribute('postWinData', 'hasLoadedCacheByBg');
		};

		_fun['costToBg'] = function (oData) {
			_pri.routePost(oData);
		};

		return _fun;
	}());

	_pri["routePost"] = function (oData) {
		switch(oData.msg) {
			case 'clearList':
				_pri.clearList();
				break;
			case 'startWin':
				_pri.startUpWindow();
				break;
			case 'upload':
				_pri.postScriptDataToPage(oData.data);
				break;
			case 'toolIsActive':
				_pri.setStatusToActive();
				break;
			
		}
		//console.log(JSON.stringify(oData, 0, 4));
	};

	_pri["setStatusToActive"] = function () {
		
	};

	_pri["getWinByPageId"] = function () {
		var oWinPage = null;
		var aWindows = $$winUtils.windows('navigator:browser', {includePrivate:false});
		//console.log('======= aWindows lenght : ' + aWindows.length);
		aWindows.some(function (aBrowser) {
			return [].some.call(aBrowser, function (oWin) {
				var sPageId;
				try{
					sPageId= oWin.document.body.getAttribute('rec-page-id');
				}catch(e) {}
				if(sPageId && sPageId === _pri.toPageId) {
					oWinPage = oWin;
					return true;
				}
			});
		});
		_pri.iBgWinLength = aWindows.length;
		return oWinPage;
	};

	_pri["postScriptDataToPage"] = function (oData) {
		//var oWinPage = _pri.getWinByPageId();
		//if(oWinPage) {
			//oWinPage.postMessage({
				//msg : 'uploadScriptData',
				//data : oData,
				//recToolSign : _pri.postSign
			//}, '*');
			//_pri.postDataToWin('getUpload');
		//}else{
			////_pri.postDataToWin('clearPageSign');
			//_pri.openCreateScriptWin(oData);
		//}
		_pri.scriptCache[oData.scriptId] = oData;
		_pri.openCreateScriptWin(oData);
	};

	_pri["scriptCache"] = {};

	_pri["openCreateScriptWin"] = function (oData) {
		var sNewScriptUrl = 'http://pts.aliyun.com/aliyun/script_new.htm?getScriptFromRecTool=';
		if(oData.testEnv === 'dev') {
			sNewScriptUrl = 'http://toy.ggg/d.html?getScriptFromRecTool=';
		}else if(oData.testEnv === 'test') {
			sNewScriptUrl = 'http://pts.aliyun.test/aliyun/script_new.htm?getScriptFromRecTool=';
		}
		var oTab = $$tabs.open({
			//url:  + oData.scriptId,
			url: sNewScriptUrl + oData.scriptId,
			//url: 'http://toy.ggg/d.html?getScriptFromRecTool=' + oData.scriptId,
			onReady: function (tab) {
				//_pri.postDataToWin('getUpload');
			}
		});
		
	};

	_pri["clearList"] = function () {
		_pri.cacheRequest.list = [];
		_pri.startServer.reqIndex = 0;
	};

	_pri["createWin"] = function (oSpec) {
		//var $$winUtils = require('sdk/addon-page');
		//var $$browserWindows = require('sdk/windows').browserWindows;
		//var $$tabs = require('sdk/tabs');
		//var oWin = $$tabs.	$$data.url('win.html'));
		//$$browserWindows.	{
			//url: $$data.url('win.html'),
			//onOpen: function(oWin) {
				//cb(oWin);
			//}
		//});
		//gBrowser.selectedTab.setAttribute("image", "chrome://alibaba_CTC_PTS_record_tool/skin/favicon.ico");
		//console.log('###########', $$data.url('win.html'));
		//var oWin = $$winUtils.open($$data.url('win.html'), {
		var sWinUrl = $$data.url('win/win.html?ver=' + $$ver);
		//sWinUrl = _pri.urlArg.url(sWinUrl);

		//var pageMod = $$pageMod.PageMod({
		  //include: sWinUrl
		  //, contentScript: 'setTimeout(function() {alert(window.windowInEx);},2000);document.title = "aaaaaaaaaaaaaaaaaa";'
		//});
		//$$tabs.open(sWinUrl);

		var oWin = $$winUtils.open(sWinUrl, {
			name : 'alibaba_CTC_PTS_record_tool_win',
			features: {
				left:0,
				top:0,
				width: 80,
				height: 80,
				resizable: true
			}
		});
		var oScreen = {
			aw : oWin.screen.availWidth,
			ah : oWin.screen.availHeight
		};
		var oScreen2 = {
			w : oScreen.aw / 2,
			h : oScreen.ah / 2
		};
		//console.log('((((((((((((((((( ' + oWin.resizeTo);
		oWin.resizeTo(oScreen2.w, oScreen.ah);
		//console.log(oScreen2.w, oScreen.ah);
		//var sArg = 'toolbar=yes,personalbar=yes,dialog=yes,minimizable=yes,fullscreen=yes,titlebar=yes,close=yes,menubar=yes,location=yes,resizable=yes,scrollbars=yes,status=yes,width='+oScreen2.w+',height='+oScreen.ah+',top=0,left='+oScreen2.w;
		//$$windowWatcher.openWindow(null, 'about:blank', 'rec-web', sArg, null);
		//$$winUtils.open('_blank', null);
		//console.log(sArg);
		//$$tabs.open({
			//url: 'http://pts.aliyun.com/aliyun/script_new.htm',
		//});
		//$$tabs.openTab(window, url, options)
		
		//var pageMod = $$pageMod.PageMod({
		  //include: 'about:blank'
		//});
		var oW = $$winUtils.openDialog({
			private: false,
			features :  'chrome,all,dialog=no,status',
			args: 'about:blank'
		})
		oW.resizeTo(oScreen2.w, oScreen.ah);
		oW.moveTo(oScreen2.w, 0);
		//var $$browserWindows = require('sdk/windows').browserWindows;debugger;
		//var oo = $$browserWindows.open({
			//url:'about:blank',
			//onOpen: function(oWin) {
				////cb(oWin);
			//}
		//});//.resizeTo(oScreen2.w, oScreen.ah);
		_pri.clearList();

		////debugger;
		//var oow = $$winUtils.getMostRecentBrowserWindow();
		var worker =  $$worker.Worker({
			window: oWin,
			contentScript:[
				'self.port.emit(\'UIready\');'
			].join('')
		});
		worker.port.on('UIready', function () {
			_pri.bindWinDoc();
		});

		//oWin.document.addEventListener('click', function () {
			//debugger;
			//console.log('onclick dddddddddddddddddddddddddddddddddddddddddddddddddddd');
		//},false);
		//oWin.document.addEventListener('load', function () {
			//debugger;
			//console.log('loadloadloadloadloadloadloadloadloadloadloadloadloadloadload');
		//},false);
 
		//window.open(
			//sWinUrl,
			//"",
			//"width=800, height=600, chrome, resizable=yes, centerscreen=yes",
			//null
		//);

		//.setAttribute("image", "resource://jid1-kjz3p6ruowzjgg-at-jetpack/code/data/logo16.png");
		//console.log($$winUtils.getOuterId(oWin));
		//console.log($$winUtils.getInnerId(oWin));
		//oWin.on('show', function() {
			//oWin.port.emit('show');
		//});

		// Listen for messages called 'text-entered' coming from
		// the content script. The message payload is the text the user
		// entered.
		// In this implementation we'll just log the text to the console.
		//oWin.port.on('text-entered', function (text) {
			//console.log(text);
			//oWin.hide();
		//});

		return oWin;
	};

	_pri["startServer"] = function (state) {
		$$Cu.import('resource://gre/modules/Services.jsm');

		Services.obs.addObserver(_pri.observe, 'http-on-modify-request', false);
		Services.obs.addObserver(_pri.observe, 'http-on-examine-response', false);
		Services.obs.addObserver(_pri.observe, 'http-on-examine-cached-response', false);
		Services.obs.addObserver(_pri.observe, 'http-on-examine-merged-response', false);
		
		//console.log('===  startServer | '+$$data.url('')+'  ===');

		_pri.startServer.ok = true;
		_pri.startServer.reqIndex = 0;
	};

	_pri["observe"] = {
		observe: function (oSubject, sTopic, oData) {
			var oHttp = oSubject.QueryInterface($$Ci.nsIHttpChannel);

			var oItem = {
				url : oHttp.URI.spec
				, method : oHttp.requestMethod
				, requestHeader : []
			};
			//console.log('%%%%%%  '+ sTopic +'  %%%%%');
			//console.log('url : ' ,oItem.url);

			var loadContext = _pri.fireFromWin(oHttp, oSubject);
			//console.log('loadContext : ', loadContext);

			if(loadContext.isContent) {

				oItem.winId = $$winUtils.getOuterId(loadContext.topWindow);
				oItem.queueId = $$winUtils.getOuterId(loadContext.topWindow);
				switch(sTopic) {
					case 'http-on-examine-cached-response':
						oItem.locCache = true;
					case 'http-on-examine-response':
						
						oItem.status = oHttp.responseStatus;
						oItem.responseHeader = [];

						if(oItem.method === 'POST') {
							var oPostReqData = _pri.getRequestPost(oHttp);
							//debugger;
							oItem.postData = oPostReqData.PostData;
							if(oPostReqData.postReqHearderEx) {
								oPostReqData.postReqHearderEx.forEach(function (aHeader) {
									if(!oItem.requestHeader.some(function (aH) {
										return aHeader[0].toLowerCase() === aH[0].toLowerCase();
									})) {
										oItem.requestHeader.push( [aHeader[0], aHeader[1]]);
									}
								});
							}
						}
						oHttp.visitRequestHeaders({
							visitHeader : function (name, value) {
								oItem.requestHeader.push( [name, value]);
							}
						});
						oHttp.visitResponseHeaders({
							visitHeader : function (name, value) {
								oItem.responseHeader.push( [name, value]);
							}
						});
						_pri.handleHttpData({
							type : 'response',
							http : oItem,
							channel : oHttp
						});

						break;
					case 'http-on-modify-request':
						
						oHttp.visitRequestHeaders({
							visitHeader : function (name, value) {
								oItem.requestHeader.push( [name, value]);
							}
						});
						_pri.handleHttpData({
							type : 'request',
							http : oItem,
							channel : oHttp
						});

						break;
					default:
						//console.log('----------- no win ------------');
						
					
				}

			}

		}
	};

	_pri["handleHttpData"] = function (oData) {
		if(oData.type === 'request') {
			oData.http.index = ++_pri.startServer.reqIndex;
			_pri.cacheRequest(oData.channel, oData.http.index);
			_pri.postHttpToWin('request', oData.http);
		}else if(oData.type === 'response') {
			_pri.checkRequest(oData);
			_pri.postHttpToWin('response', oData.http);
		}
	};

	_pri["cacheRequest"] = function (oChannel, iIndex) {
		if(!_pri.cacheRequest.list) {
			_pri.cacheRequest.list = [];
		}
		_pri.cacheRequest.list.push([oChannel, iIndex]);
	};

	_pri["checkRequest"] = function (oData) {
		if(_pri.cacheRequest.list) {
			if(!_pri.cacheRequest.list.some(function (aD, i) {
				var bMatch = (aD[0] === oData.channel);
				if(bMatch) {
					_pri.cacheRequest.list.splice(i, 1);
					oData.http.index = aD[1];
				}
				return bMatch;
			})) {
				oData.http.index = ++_pri.startServer.reqIndex;
			};
		}
	};

	_pri["fireFromWin"] = function (httpChannel, subject) {
		
		var loadContext = {
			isContent : false
		};
		try {
			var interfaceRequestor = httpChannel.notificationCallbacks.QueryInterface($$Ci.nsIInterfaceRequestor);
			//var DOMWindow = interfaceRequestor.getInterface($$Ci.nsIDOMWindow); //not to be done anymore because: https://developer.mozilla.org/en-US/docs/Updating_extensions_for_Firefox_3.5#Getting_a_load_context_from_a_request //instead do the loadContext stuff below
			try {
				loadContext = interfaceRequestor.getInterface($$Ci.nsILoadContext);
			} catch (ex) {
				try {
					loadContext = subject.loadGroup.notificationCallbacks.getInterface($$Ci.nsILoadContext);
				} catch (ex2) {}
			}
		} catch (ex0) {}

		//associatedWindow.document
		//isContent
		//if(loadContext.topWindow && !loadContext.topWindow.uuid) {
			//loadContext.topWindow.uuid = Math.random() + '';
		//}
		return loadContext;
	};

	_pri["readFromStream_Binary"] = function(stream, charset) {
		var bstream = $$Cc["@mozilla.org/binaryinputstream;1"].createInstance($$Ci.nsIBinaryInputStream);
		bstream.setInputStream(stream);

		var bytes = bstream.readBytes(bstream.available());
		return bytes;
	};

//* ***********************************************************************************************
// HttpFoxPostDataHandler
	// Contains code from LiveHeaders and TamperData
	function HttpFoxPostDataHandler(hfRequest) 
	{
		this.request = hfRequest;
		this.request.IsPostDataMIME = false;
		this.seekablestream = this.request.HttpChannel.uploadStream.QueryInterface($$Ci.nsISeekableStream);
		this.stream = $$Cc["@mozilla.org/scriptableinputstream;1"].createInstance($$Ci.nsIScriptableInputStream);
		this.stream.init(this.seekablestream);

		// Check if the stream has headers
		this.hasheaders = false;
		this.body = 0;
		this.isBinary = true;
		if (this.seekablestream instanceof $$Ci.nsIMIMEInputStream) 
		{
			this.seekablestream.QueryInterface($$Ci.nsIMIMEInputStream);
			this.hasheaders = true;
			this.body = -1; // Must read header to find body
			this.isBinary = false;
		} 
		else if (this.seekablestream instanceof $$Ci.nsIStringInputStream) 
		{
			this.seekablestream.QueryInterface($$Ci.nsIStringInputStream);
			this.hasheaders = true;
			this.body = -1; // Must read header to find body
		}
	}

	HttpFoxPostDataHandler.prototype = 
	{
		rewind: function() 
		{
			this.seekablestream.seek(0, 0);
		},

		tell: function() 
		{
			return this.seekablestream.tell();
		},

		readLine: function() 
		{
			var line = "";
			var size = this.stream.available();
			for (var i = 0; i < size; i++) 
			{
				var c = this.stream.read(1);
				if (c == '\r') 
				{} 
				else if (c == '\n') 
				{
					break;
				} 
				else
				{
					line += c;
				}
			}
			return line;
		},

		getPostHeaders: function() 
		{
			if (this.hasheaders) 
			{
				this.rewind();
				var line = this.readLine();
				while(line) 
				{
					if (this.request) 
					{
						var tmp = line.split(/:\s?/);
						this.addPostHeader(tmp[0], tmp[1]);
						// check if MIME postdata
						if (tmp[0].toLowerCase() == "content-type" && tmp[1].indexOf("multipart") != "-1") 
						{
							this.isBinary = true;
							this.request.IsPostDataMIME = true;
							this.request.PostDataMIMEBoundary = "--" + tmp[1].split("boundary=")[1];
							if (this.request.PostDataMIMEBoundary.indexOf("\"") === 0)
							{
								this.request.PostDataMIMEBoundary = this.request.PostDataMIMEBoundary.substr(1, this.request.PostDataMIMEBoundary.length - 2);
							}
						}else if(tmp[0].toLowerCase() === 'content-type' && tmp[1].toLowerCase() == 'application/x-www-form-urlencoded')  {
							this.addPostReqHearderEx(tmp);
						}else if(tmp[0].toLowerCase() === 'content-length')  {
							this.addPostReqHearderEx(tmp);
						}
					}
					line = this.readLine();
				}
				this.body = this.tell();
			}
		},

		addPostReqHearderEx : function (tmp) {
			this.request.postReqHearderEx = this.request.postReqHearderEx || [];
			this.request.postReqHearderEx.push(tmp);
		},
		
		addPostHeader: function(name, value)
		{
			if (!this.request.PostDataHeaders) 
			{
				this.request.PostDataHeaders = [];
			}
			this.request.PostDataHeaders[name] = value;
		},

		clearPostHeaders : function() 
		{
			if (this.request.PostDataHeaders) 
			{
				delete this.request.PostDataHeaders;
			}
		},
		
		getPostData: function() 
		{
			var i, u, v;

			// Position the stream to the start of the body
			if (this.body < 0 || this.seekablestream.tell() != this.body) 
			{
				this.getPostHeaders();
			}
		
			var size = this.stream.available();
			if (size === 0 && this.body !== 0) 
			{
				// whoops, there weren't really headers..
				this.rewind();
				this.clearPostHeaders();
				size = this.stream.available();
			}
			
			// read post body (only if non-binary/too big)
			var postString = "";
			
			try 
			{
				if (size < 500000)
				{
					// This is to avoid 'NS_BASE_STREAM_CLOSED' exception that may occurs
					// See bug #188328.
					for (u = 0; u < size; u++) 
					{
						var c = this.stream.read(1);
						if (c) {
							postString += c;
						} 
						else {
							postString += '\0';
						}
					}	
				}
				else 
				{
					this.request.IsPostDataTooBig = true;
				}
			} 
			catch(e)
			{
				dump("\nExc: " + e);
				return "" + e;
			} 
			finally 
			{
				this.rewind();
			}
			
			// if mime than try to split in parts
			if (this.request.IsPostDataMIME) 
			{
				this.request.PostData = postString;
				this.request.PostDataMIMEParts = [];
				
				if (!this.request.IsPostDataTooBig)
				{
					var rawMimeParts = [];
					rawMimeParts = postString.split(this.request.PostDataMIMEBoundary);
					
					var ws = "\n";
					if (rawMimeParts[1].indexOf("\r\n") === 0)
					{
						ws = "\r\n";
					}
					else if (rawMimeParts[1].indexOf("\r") === 0)
					{
						ws = "\r";
					}
					
					for (i = 1; rawMimeParts[i]; i++)
					{
						try 
						{
							var re;
							var mimePartData = {};
							var rawMimePartParts = [];
							rawMimePartParts = rawMimeParts[i].split(ws + ws);	
							
							var varname = null;
							re = new RegExp('\bname="([^"]+)"', "i");
							if (rawMimePartParts[0].match(re)) 
							{
								varname = re.$1;
							}
							if (!varname) 
							{
								re = new RegExp('\bname=([^\s:;]+)', "i");
								if(rawMimePartParts[0].match(re)) 
								{
									varname = re.$1;
								}
							}
							
							if (varname !== null)
							{
								var filename = null;
								re = new RegExp('\b(filename="[^"]*")', "i");
								if (rawMimePartParts[0].match(re)) 
								{
									filename = re.$1;
								}
								if (!filename) 
								{
									re = new RegExp('\b(filename=[^\s:;]+)', "i");
									if(rawMimePartParts[0].match(re)) 
									{
										filename = re.$1;
									}
								}
				
								var ctype = null;
								re = new RegExp('\b(Content-type:\s*"[^"]+)"', "i");
								if (rawMimePartParts[0].match(re)) 
								{
									ctype = re.$1;
								}
								if (!ctype) 
								{
									re = new RegExp('\b(Content-Type:\s*[^\s:;]+)', "i");
									if (rawMimePartParts[0].match(re)) {
										ctype = re.$1;
									}
								}
								
								// value
								var value = utils.trim(rawMimePartParts[1]);
								
								mimePartData.varname = varname;
								mimePartData.filename = filename;
								mimePartData.ctype = ctype;
								mimePartData.value = value;
								
								this.request.PostDataMIMEParts.push(mimePartData);
							}
						}
						catch(e)
						{
							dump("\n\nEXC: " + e);
						}
					}
					
					return null;
				}
			}
			
			// strip off trailing \r\n's
			while (postString.indexOf("\r\n") == (postString.length - 2))
			{
				postString = postString.substring(0, postString.length - 2);
			}
			this.request.PostData = postString;
			
			// check if url parameter style
			if (this.request.PostData.match(/^&?([^=&<>]+=[^=&]*&?)+/i)) 
			{
				// split parameters (only non-mime bodies)
				this.request.PostDataParameters = [];
				var postDataParts = this.request.PostData.split("&");
				for (v in postDataParts)
				{
					if (postDataParts.hasOwnProperty(v)) {
						var nameValuePair = postDataParts[v].split("=");
						this.request.PostDataParameters.push([nameValuePair[0], nameValuePair[1]]);	
					}
				}
				return null;		
			}
			
			// no parseable content. display raw.
			this.request.PostDataParameters = null;
			return null;
		}
	};

	

	_pri["getRequestPost"] = function (channel) {


				// Get the postData stream from the Http Object 
				try {
					// Must change HttpChannel to UploadChannel to be able to access post data
					var postChannel = channel.QueryInterface($$Ci.nsIUploadChannel);

					// Get the post data stream
					if (postChannel.uploadStream) 
					{
						//this.PostDataChannel = postChannel;
						var PostDataHandler = new HttpFoxPostDataHandler({
							HttpChannel : channel
						});
						
						debugger;
						PostDataHandler.getPostData();
						debugger;
					} 
				} 
				catch(ex) {}

				

		let post = PostDataHandler.request;
		//if (!(channel instanceof $$Ci.nsIHttpChannel) ||
			//!(channel instanceof $$Ci.nsIUploadChannel)) {
			//return post;
		//}
		//if (channel.requestMethod !== 'POST') {
			//return post;
		//}

		//try {
			//let us = channel.uploadStream;
			//if (!us) {
				//return post;
			//}
			//if (us instanceof $$Ci.nsIMultiplexInputStream) {
				//// Seeking in a nsIMultiplexInputStream effectively breaks the stream.
				//return post;
			//}
			//if (!(us instanceof $$Ci.nsISeekableStream)) {
				//// Cannot seek within the stream :(
				//return post;
			//}

			//let oldpos = us.tell();
			//us.seek(0, 0);

			//try {
				////var ScriptableInputStream = $$Cc("@mozilla.org/scriptableinputstream;1", "nsIScriptableInputStream", "init");
				//var ScriptableInputStream = $$Cc["@mozilla.org/scriptableinputstream;1"].createInstance($$Ci.nsIScriptableInputStream);
				//ScriptableInputStream.init(us);
				//let is = ScriptableInputStream;

				//// we'll read max 64k
				//let available = Math.min(is.available(), 1 << 16);
				//if (available) {
					//post = is.read(available);
				//}
			//}
			//finally {
				//// Always restore the stream position!
				//us.seek(0, oldpos);
			//}
		//}
		//catch (ex) {
			//$$Cu.reportError(ex);
		//}
		return post;
	};


	_pri["urlArg"] = (function(global){

		/**
		 * MakeArg makes the Arg namespace.
		 * var Arg = MakeArg();
		 */
		var MakeArg = function(){

			/** @namespace
			 */
			var Arg = function(){
				return Arg.get.apply(global, arguments);
			};
			Arg.version = "1.2.0";

			/**
			 * Parses the arg string into an Arg.Arg object.
			 */
			Arg.parse = function(s){
				if (!s) return {};
				if (s.indexOf("=")===-1 && s.indexOf("&")===-1) return {};
				s = Arg._cleanParamStr(s);
				var obj = {};
				var pairs = s.split("&");
				for (var pi in pairs) {
					if(pairs.hasOwnProperty(pi)){
						var kvsegs = pairs[pi].split("=");
						var key = decodeURIComponent(kvsegs[0]), val = Arg.__decode(kvsegs[1]);
						Arg._access(obj, key, val);
					}
				}
				return obj;
			};

			/**
			 * Decodes a URL component (including resolving + to spaces)
			 */
			Arg.__decode = function(s) {
				while (s && s.indexOf("+")>-1) {
					s = s.replace("+", " ");
				};
				s = decodeURIComponent(s);
				return s;
			};

			/**
			 * Helper method to get/set deep nested values in an object based on a string selector
			 *
			 * @param	{Object}	obj				Based object to either get/set selector on
			 * @param	{String}	selector	 Object selector ie foo[0][1].bar[0].baz.foobar
			 * @param	{Mixed}	 value			(optional) Value to set leaf located at `selector` to.
			 *															If value is undefined, operates in 'get' mode to return value at obj->selector
			 * @return {Mixed}
			 */
			Arg._access = function(obj, selector, value) {
				var shouldSet = typeof value !== "undefined";
				var selectorBreak = -1;
				var coerce_types = {
					'true'	: true,
					'false' : false,
					'null'	: null
				};

				// selector could be a number if we're at a numerical index leaf in which case selector.search is not valid
				if (typeof selector == 'string' || toString.call(selector) == '[object String]') {
					selectorBreak = selector.search(/[\.\[]/);
				}

				// No dot or array notation so we're at a leaf, set value
				if (selectorBreak === -1) {
					if (Arg.coerceMode) {
						value = value && !isNaN(value)						? +value							// number
									: value === 'undefined'						 ? undefined					 // undefined
									: coerce_types[value] !== undefined ? coerce_types[value] // true, false, null
									: value;																		// string
					}
					return shouldSet ? (obj[selector] = value) : obj[selector];
				}

				// Example:
				// selector		 = 'foo[0].bar.baz[2]'
				// currentRoot	= 'foo'
				// nextSelector = '0].bar.baz[2]' -> will be converted to '0.bar.baz[2]' in below switch statement
				var currentRoot = selector.substr(0, selectorBreak);
				var nextSelector = selector.substr(selectorBreak + 1);

				switch (selector.charAt(selectorBreak)) {
					case '[':
						// Intialize node as an array if we haven't visted it before
						obj[currentRoot] = obj[currentRoot] || [];
						nextSelector = nextSelector.replace(']', '');

						if (nextSelector.search(/[\.\[]/) === -1) {
							nextSelector = parseInt(nextSelector, 10);
						}

						return Arg._access(obj[currentRoot], nextSelector, value);
					case '.':
						// Intialize node as an object if we haven't visted it before
						obj[currentRoot] = obj[currentRoot] || {};
						return Arg._access(obj[currentRoot], nextSelector, value);
				}

				return obj;
			};

			/**
			 * Turns the specified object into a URL parameter string.
			 */
			Arg.stringify = function(obj, keyPrefix) {

				switch (typeof(obj)) {
				case "object":
					var segs = [];
					var thisKey;
					for (var key in obj) {

						if (!obj.hasOwnProperty(key)) continue;
						var val = obj[key];

						if (typeof(key) === "undefined" || key.length === 0 || typeof(val) === "undefined") continue;

						thisKey = keyPrefix ? keyPrefix+"."+key : key;

						if (typeof obj.length !== "undefined") {
							thisKey = keyPrefix ? keyPrefix+"["+key+"]" : key;
						}

						if (typeof val === "object") {
							segs.push(Arg.stringify(val, thisKey));
						} else {
							segs.push(encodeURIComponent(thisKey)+"="+encodeURIComponent(val));
						}

					}
					return segs.join("&");
				}

				return encodeURIComponent(obj);

			};

			/**
			 * Generates a URL with the given parameters.
			 * (object) = A URL to the current page with the specified parameters.
			 * (path, object) = A URL to the specified path, with the object of parameters.
			 * (path, object, object) = A URL to the specified path with the first object as query parameters,
			 * and the second object as hash parameters.
			 */
			Arg.url = function(){

				var sep = (Arg.urlUseHash ? Arg.hashQuerySeperator : Arg.querySeperator);
				var segs = [null, sep];
				var args = {};

				switch (arguments.length) {
				case 1: // Arg.url(params)
					segs = [location.pathname, sep];
					segs.push(Arg.stringify(arguments[0]));
					break;
				case 2: // Arg.url(path, params)
					segs[0] = Arg._cleanPath(arguments[0]);
					args = Arg.parse(arguments[0]);
					args = Arg.merge(args, arguments[1]);
					segs.push(Arg.stringify(args));
					break;
				case 3: // Arg.url(path, query, hash)
					segs[0] = Arg._cleanPath(arguments[0]);
					segs[1] = Arg.querySeperator;
					segs.push(Arg.stringify(arguments[1]));
					(typeof(arguments[2])==="string") ? segs.push(Arg.hashSeperator) : segs.push(Arg.hashQuerySeperator);
					segs.push(Arg.stringify(arguments[2]));
				}

				var s = segs.join("");

				// trim off sep if it's the last thing
				if (s.indexOf(sep) == s.length - sep.length) {
					s = s.substr(0, s.length - sep.length);
				}

				return s;

			};

			/** urlUseHash tells the Arg.url method to always put the parameters in the hash. */
			Arg.urlUseHash = false;

			/** The string that seperates the path and query parameters. */
			Arg.querySeperator = "?";

			/** The string that seperates the path or query, and the hash property. */
			Arg.hashSeperator = "#";

			/** The string that seperates the the path or query, and the hash query parameters. */
			Arg.hashQuerySeperator = "#?";

			/** When parsing values if they should be coerced into primitive types, ie Number, Boolean, Undefined */
			Arg.coerceMode = true;

			/**
			 * Gets all parameters from the current URL.
			 */
			Arg.all = function(){
				var merged = Arg.parse(Arg.querystring() + "&" + Arg.hashstring());
				return Arg._all ? Arg._all : Arg._all = merged;
			};

			/**
			 * Gets a parameter from the URL.
			 */
			Arg.get = function(selector, def){
				var val = Arg._access(Arg.all(), selector);
				return typeof(val) === "undefined" ? def : val;
			};

			/**
			 * Gets the query string parameters from the current URL.
			 */
			Arg.query = function(){
				return Arg._query ? Arg._query : Arg._query = Arg.parse(Arg.querystring());
			};

			/**
			 * Gets the hash string parameters from the current URL.
			 */
			Arg.hash = function(){
				return Arg._hash ? Arg._hash : Arg._hash = Arg.parse(Arg.hashstring());
			};

			/**
			 * Gets the query string from the URL (the part after the ?).
			 */
			Arg.querystring = function(){
				return Arg._cleanParamStr(location.search);
			};

			/**
			 * Gets the hash param string from the URL (the part after the #).
			 */
			Arg.hashstring = function(){
				return Arg._cleanParamStr(location.hash)
			};

			/*
			 * Cleans the URL parameter string stripping # and ? from the beginning.
			 */
			Arg._cleanParamStr = function(s){

				if (s.indexOf(Arg.querySeperator)>-1)
					s = s.split(Arg.querySeperator)[1];

				if (s.indexOf(Arg.hashSeperator)>-1)
					s = s.split(Arg.hashSeperator)[1];

				if (s.indexOf("=")===-1 && s.indexOf("&")===-1)
					return "";

				while (s.indexOf(Arg.hashSeperator) == 0 || s.indexOf(Arg.querySeperator) == 0)
					s = s.substr(1);

				return s;
			};

			Arg._cleanPath = function(p){

				if (p.indexOf(Arg.querySeperator)>-1)
					p = p.substr(0,p.indexOf(Arg.querySeperator));

				if (p.indexOf(Arg.hashSeperator)>-1)
					p = p.substr(0,p.indexOf(Arg.hashSeperator));

				return p;
			};

			/**
			 * Merges all the arguments into a new object.
			 */
			Arg.merge = function(){
				var all = {};
				for (var ai in arguments){
					if(arguments.hasOwnProperty(ai)){
						for (var k in arguments[ai]){
							if(arguments[ai].hasOwnProperty(k)){
								all[k] = arguments[ai][k];
							}
						}
					}
				}
				return all;
			};

			return Arg;

		};

		/** @namespace
		 * Arg is the root namespace for all arg.js functionality.
		 */
		return MakeArg();

	})();



	_init();


}());






